<script setup lang="ts">
import { computed, onMounted, type PropType, ref, watch } from "vue";
import type { ExtendedColors, SizeModifierType } from "@/types/PropTypes";

const model = defineModel({ required: true });

const props = defineProps({
  parameter: {
    type: Object,
    required: true,
    validator(value: Record<string, never>) {
      return value["enum"];
    },
  },
  required: Boolean,
  sizeModifier: {
    type: String as PropType<SizeModifierType>,
  },
  border: String as PropType<ExtendedColors>,
  id: String,
  customValidity: { type: String, required: false },
});

watch(
  () => props.customValidity,
  (newVal, oldVal) => {
    if (newVal != oldVal) {
      enumSelect.value?.setCustomValidity(newVal ?? "");
    }
  },
);

const enumSelect = ref<HTMLSelectElement | undefined>(undefined);

const possibleValues = computed<string[]>(() => props.parameter["enum"]);

const dynamicCssClasses = computed<string[]>(() => {
  const cssClasses = [];
  if (props.sizeModifier) {
    cssClasses.push(`form-select-${props.sizeModifier}`);
  }
  if (props.border) {
    cssClasses.push("border", `border-${props.border}`);
  }
  return cssClasses;
});

onMounted(() => {
  enumSelect.value?.setCustomValidity(props.customValidity ?? "");
});
</script>

<template>
  <select
    :id="id"
    ref="enumSelect"
    v-model="model"
    class="form-select"
    :class="dynamicCssClasses"
    :required="props.required"
  >
    <option v-for="val in possibleValues" :key="val">
      {{ val }}
    </option>
  </select>
</template>

<style scoped></style>
